<?php


$fd = -1;
$done = 0;
$total = 0;
$url = "";
$fname = "";


include("common.php");
include("curl_helper.php");


function http_body_reader($ch, $str)
{
  /* This is the GET response. */

  global $fd;
  global $done;
  global $total;

  /* Write the string to the file. */
  $written = fwrite($fd, $str);

  if ($written != strlen($str))
    die("Error writing " . strlen($str) . " bytes to the file.\n");

  $done += $written;
  return $written;

}


if ($_SERVER["argc"] < 4)
{
  die("Usage: " . $_SERVER["argv"][0] . " <\"URL\"> <\"FILE NAME\"> <\"FILE SIZE\">\n");
}


$url   = $_SERVER["argv"][1];
$fname = $_SERVER["argv"][2];
$fsize = $_SERVER["argv"][3];

$fd = fopen($download_dir . $fname, "w");

if (!$fd)
  die("Error opening file: " . $download_dir . $fname . " for WRITING.\n");


write_metadata($url, $fname, $fsize, time(), posix_getpid());


download_file($url, "http_body_reader");

/* Write out to the metadata file signalling that the download is NOT
 * running.
 * 
 */
$fmd_path = $metadata_dir . $fname;
$file_metadata = file($fmd_path);

if ($file_metadata !== FALSE)
{
  /* Write out a '0' to the 'status' flag in the metadata information
   * file.
   */
  $file_metadata[3] = "0\n";
  write_string_to_file($fmd_path, implode("", $file_metadata));
}



?>
