<?php


include("curl_helper.php");


$str_month = array("", "JAN", "FEB", "MAR", "APR", "MAY", 
		   "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC");


function download_bhavcopy($url)
{
  $conn = new CCurl();

  $conn->set_url($url);
  $conn->include_header(1);
  $conn->set_http_request_method("GET");

  $conn->execute();

  echo $conn->m_header . "\n";

  $harray = explode("\r\n", $conn->m_header);

  echo "HTTP Response Code: " . http_response_code($harray[0]) . "\n";

  if (http_response_code($harray[0]) == "200")
  {
    return $conn->m_body;
  }
  else
  {
    return FALSE;
  }

}


function make_url($date, $month, $year)
{
  global $str_month;

  if ($date < 10)
  {
    $date = "0" . $date;
  }

  $month = $str_month[$month];

  $url = "http://www.nseindia.com/content/historical/EQUITIES/" . $year . "/" . 
	 $month . "/cm" . $date . $month . $year . "bhav.csv";

  // echo $url . "\n";
  return $url;
}


for ($i = 1; $i < 31; ++$i)
{
  echo download_bhavcopy(make_url($i, 1, 2008));
}



?>
