<?php


include("common.php");


// print_r($_SERVER);

// echo $_SERVER["REDIRECT_URL"] . "\n";


function get_server_prefix()
{
  return substr($_SERVER["SCRIPT_NAME"], 0, strpos($_SERVER["SCRIPT_NAME"], "/get_file.php"));
}


function send_HTTP_404($url)
{
  header("HTTP/1.1 404 Not Found", true, 404);
  echo "<html>\n<head>\n<title>404 Not Found\n</title></head>\n\n";
  echo "<body>\n<h1>404 Not Found</h1><hr><br>\n";
  echo "<big>The document <tt>" . htmlspecialchars($url) . "</tt> was NOT found on this server.</big><br><br>\n";
  echo "<a href=\"" . get_server_prefix() . "/\">Calsoft downloader Home</a><br>\n</body>\n</html>\n";
}

/* Set the no-cache header. */
header("Cache-Control: no-cache");


$url = urldecode($_SERVER["REDIRECT_URL"]);
$file_prefix = get_server_prefix() . "/files/";


/* Check if "$file_prefix" is present at index "0" if the URL. */
$pos = strpos($url, $file_prefix);

if ($pos === FALSE || $pos !== 0)
{
  /* This is a malformed URL. Send a 404 message. */
  send_HTTP_404($url);
  exit;
}

$file_name = substr($url, strlen($file_prefix));
$file_path = $download_dir . $file_name;

if ((strlen($file_name) == 0) || 
   (file_exists($file_path) == FALSE))
{
  send_HTTP_404($url);
  exit;
}

$shell_file_path = escapeshellarg($file_path);
$mime_type = rtrim(`file -bi $shell_file_path`);

$file_size = filesize($file_path);


header("HTTP/1.1 200 OK", true, 200);
header("Content-Type: " . $mime_type);
header("Content-Length: " . $file_size);

/* Send ONLY $file_size bytes to the client. */

$fh = fopen($file_path, "r");

$block_size = 65536;
$xfer_left = $file_size;

/* Assume this succeeded. */

while ($xfer_left > 0)
{
  $to_read = ($xfer_left >= $block_size ? $block_size : $xfer_left);
  $data = fread($fh, $to_read);
  echo $data;
  $xfer_left -= $to_read;
}


?>
